const REGULAR_STRING = {
    HTML_STYLE_TAG: '<[^<>]+>',
    ENTER: '[\n\r]',
};

Utils = {
    htmlDecode: function (text) {
        return !text ? "" : (text + "").replaceAll("&amp;|&dollar;|&lcub;|&rcub;|&quot;|&lt;|&gt;|&nbsp;", function (v) {
            switch (v) {
                case "&amp;":
                    return "&";
                case "&dollar;":
                    return "$";
                case "&lcub;":
                    return "{";
                case "&rcub;":
                    return "}";
                case "&quot;":
                    return "\"";
                case "&lt;":
                    return "<";
                case "&gt;":
                    return ">";
                case "&nbsp;":
                default:
                    return " ";
            }
        });
    },

    getPlainText: function (name) {
        return Utils.htmlDecode(
            name.replace(new RegExp(REGULAR_STRING.HTML_STYLE_TAG, "gm"), '').replace(new RegExp(REGULAR_STRING.ENTER, "gm"), '')
        )
    },

}
