# 使用方法

打开根目录下的index.html即可看到评分页面

# 开发教程

## 评分思路

每套试卷都需要一个类处理该套评分规则，每个评分点通过配置的对比，来判断是否给分。

### 如何知道评分点对应的配置

方式1：页面上操作查看模板的`save`请求，通过前后JSON配置的对比知道操作对应的配置，从而在开发过程中知道按照什么配置对比给分

方式2：做完一个操作前后，如改变图表类型，都进行资源迁移导出配置，解压zip，查看`dashboard\xxx.fbi`文件，文件中配置需要经过JSON.stringify(xxx)，转成JSON格式，通过JSON配置对比，知道操作对应的配置

注意：JSON配置对比可用[https://www.diffchecker.com/]

### 评分点对应的配置有几种类型

1. 直接配置变化，如切换成分组表，对应的 widget.type 变化，对比widget.getWidgetType()是否等于1即可，参考`paper\paper_1.js`中`score_2`方法
2. 一个评分点对应了多个配置，如添加了三个字段，对应的widget.dimensions中多了三个维度，且顺序存在widget.view[10000]中，需要通过多分配置计算对比，才能知道是否得分

## 如果添加一套试卷的评分点

1. 在`index.html`的`<select>`中添加一个`<options>`
2. 在`paper/`目录下添加一套试卷评分的处理类，格式和逻辑见`paper_1.js`
3. 在`index.js`中`startButton.onclick`方法里添加一条`case`，用于处理新添加的试卷

## 注意事项/难点

1. 组件标题是富文本，需要解析富文本才能拿到颜色、背景等属性
2. 一条评分点可能对应多个配置的变化，如何识别关键配置，并对比是难点所在
3. 评分点的要求有时候需要具象到代码层面，如`标题黑色`，但其实在代码中纯黑色`#000000`,`#212121`也是黑色，这时候在拿到颜色后，需要一个判断是否是暗色的方法，判断配置中颜色是否是暗色
4. 对BI产品的属性程度，比如`标题黑色`，不仅可以在组件标题中设置，仪表板样式和平台样式也可以影响标题颜色，例如：仪表板样式标题是黑色，组件标题也是黑色，但这时候组件标题里颜色配置是自动配置（也就是无任何配置从而继承仪表板样式中的颜色）